<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: fhog_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_92d89ec45d405da5484bb10cba76683e.html">image_transforms</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">fhog_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2013  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_fHOG_ABSTRACT_Hh_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_fHOG_ABSTRACT_Hh_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;../matrix/matrix_abstract.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;../array2d/array2d_kernel_abstract.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;../array/array_kernel_abstract.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;../image_processing/generic_image.h&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;{</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;        <span class="keyword">typename</span> image_type, </div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        <span class="keyword">typename</span> T, </div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        <span class="keyword">typename</span> mm</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        &gt;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <span class="keywordtype">void</span> extract_fhog_features(</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        <span class="keyword">const</span> image_type&amp; img, </div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        array2d&lt;matrix&lt;T,31,1&gt;,mm&gt;&amp; hog, </div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        <span class="keywordtype">int</span> cell_size = 8,</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        <span class="keywordtype">int</span> filter_rows_padding = 1,</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;        <span class="keywordtype">int</span> filter_cols_padding = 1</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    );</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160; </div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        <span class="keyword">typename</span> image_type,</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        <span class="keyword">typename</span> T, </div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        <span class="keyword">typename</span> mm1, </div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        <span class="keyword">typename</span> mm2</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        &gt;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <span class="keywordtype">void</span> extract_fhog_features(</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        <span class="keyword">const</span> image_type&amp; img, </div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        <a class="code" href="classdlib_1_1array.html">dlib::array</a>&lt;array2d&lt;T,mm1&gt;,mm2&gt;&amp; hog, </div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        <span class="keywordtype">int</span> cell_size = 8,</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        <span class="keywordtype">int</span> filter_rows_padding = 1,</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        <span class="keywordtype">int</span> filter_cols_padding = 1</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    );</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160; </div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        <span class="keyword">typename</span> image_type</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        &gt;</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    matrix&lt;double,0,1&gt; extract_fhog_features(</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;        <span class="keyword">const</span> image_type&amp; img, </div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;        <span class="keywordtype">int</span> cell_size = 8,</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        <span class="keywordtype">int</span> filter_rows_padding = 1,</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        <span class="keywordtype">int</span> filter_cols_padding = 1</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    );</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160; </div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        <span class="keyword">typename</span> image_type,</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        &gt;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    <span class="keywordtype">void</span> extract_fhog_features(</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;        <span class="keyword">const</span> image_type&amp; img, </div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        matrix&lt;T,0,1&gt;&amp; feats,</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        <span class="keywordtype">int</span> cell_size = 8,</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        <span class="keywordtype">int</span> filter_rows_padding = 1,</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        <span class="keywordtype">int</span> filter_cols_padding = 1</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    );</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160; </div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    <span class="keyword">inline</span> point image_to_fhog (</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        point p,</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        <span class="keywordtype">int</span> cell_size = 8,</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        <span class="keywordtype">int</span> filter_rows_padding = 1,</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        <span class="keywordtype">int</span> filter_cols_padding = 1</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    );</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160; </div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    <span class="keyword">inline</span> rectangle image_to_fhog (</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        <span class="keyword">const</span> rectangle&amp; rect,</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;        <span class="keywordtype">int</span> cell_size = 8,</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;        <span class="keywordtype">int</span> filter_rows_padding = 1,</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        <span class="keywordtype">int</span> filter_cols_padding = 1</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;    );</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160; </div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;    <span class="keyword">inline</span> point fhog_to_image (</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;        point p,</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;        <span class="keywordtype">int</span> cell_size = 8,</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;        <span class="keywordtype">int</span> filter_rows_padding = 1,</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;        <span class="keywordtype">int</span> filter_cols_padding = 1</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;    );</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160; </div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;    <span class="keyword">inline</span> rectangle fhog_to_image (</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;        <span class="keyword">const</span> rectangle&amp; rect,</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;        <span class="keywordtype">int</span> cell_size = 8,</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;        <span class="keywordtype">int</span> filter_rows_padding = 1,</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;        <span class="keywordtype">int</span> filter_cols_padding = 1</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;    );</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160; </div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;        <span class="keyword">typename</span> T, </div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;        <span class="keyword">typename</span> mm1, </div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;        <span class="keyword">typename</span> mm2</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;        &gt;</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;    matrix&lt;unsigned char&gt; draw_fhog(</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;        <span class="keyword">const</span> <a class="code" href="classdlib_1_1array.html">dlib::array</a>&lt;array2d&lt;T,mm1&gt;,mm2&gt;&amp; hog,</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">long</span> cell_draw_size = 15</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;    );</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160; </div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;        &gt;</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;    matrix&lt;unsigned char&gt; draw_fhog (</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;        <span class="keyword">const</span> std::vector&lt;matrix&lt;T&gt; &gt;&amp; hog,</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">long</span> cell_draw_size = 15</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;    );</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160; </div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;        <span class="keyword">typename</span> T, </div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;        <span class="keyword">typename</span> mm</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;        &gt;</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;    matrix&lt;unsigned char&gt; draw_fhog(</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;        <span class="keyword">const</span> array2d&lt;matrix&lt;T,31,1&gt;,mm&gt;&amp; hog,</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">long</span> cell_draw_size = 15</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;    );</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160; </div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;}</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160; </div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;<span class="preprocessor">#endif // DLIB_fHOG_ABSTRACT_Hh_</span></div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160; </div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassdlib_1_1array_html"><div class="ttname"><a href="classdlib_1_1array.html">dlib::array</a></div><div class="ttdef"><b>Definition:</b> array_kernel.h:20</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
